searchNodes=[{"doc":"Relay support for Absinthe.Global Identification: See Absinthe.Relay.NodeConnection Model: See Absinthe.Relay.ConnectionMutations: See Absinthe.Relay.MutationExamplesSchemas should use Absinthe.Relay.Schema and can optionally select either :modern (targeting Relay v1.0+) or :classic (targeting Relay &lt; v1.0):defmodule Schema do use Absinthe.Schema use Absinthe.Relay.Schema, :modern # ... endFor a type module, use Absinthe.Relay.Schema.Notation instead:defmodule Schema do use Absinthe.Schema.Notation use Absinthe.Relay.Schema.Notation, :modern # ... endIf you do not indicate :modern or :classic---in v1.4 of this package---the default of :classic will be used. A deprecation notice will be output indicating that this behavior will change in v1.5 (to :modern).See Absinthe.Relay.Node, Absinthe.Relay.Connection, and Absinthe.Relay.Mutation for specific macro information.","ref":"Absinthe.Relay.html","title":"Absinthe.Relay","type":"module"},{"doc":"Support for paginated result sets.Define connection types that provide a standard mechanism for slicing and paginating result sets.For information about the connection model, see the Relay Cursor Connections Specification at https://facebook.github.io/relay/graphql/connections.htm.ConnectionGiven an object type, eg:object :pet do field :name, :string endYou can create a connection type to paginate them by:connection node_type: :petThis will automatically define two new types: :pet_connection and :pet_edge.We define a field that uses these types to paginate associated records by using connection field. Here, for instance, we support paginating a person's pets:object :person do field :first_name, :string connection field :pets, node_type: :pet do resolve fn pagination_args, %{source: person} -&gt; Absinthe.Relay.Connection.from_list( Enum.map(person.pet_ids, &amp;pet_from_id(&amp;1)), pagination_args ) end end end endThe :pets field is automatically set to return a :pet_connection type, and configured to accept the standard pagination arguments after, before, first, and last. We create the connection by using Absinthe.Relay.Connection.from_list/2, which takes a list and the pagination arguments passed to the resolver.It is possible to provide additional pagination arguments to a relay connection:connection field :pets, node_type: :pet do arg :custom_arg, :custom # other args... resolve fn pagination_args_and_custom_args, %{source: person} -&gt; # ... return {:ok, a_connection} end endNote: Absinthe.Relay.Connection.from_list/2 expects that the full list of records be materialized and provided. If you're using Ecto, you probably want to use Absinthe.Relay.Connection.from_query/2 instead.Here's how you might request the names of the first $petCount pets a person owns:query FindPets($personId: ID!, $petCount: Int!) { person(id: $personId) { pets(first: $petCount) { pageInfo { hasPreviousPage hasNextPage } edges { node { name } } } } }edges here is the list of intermediary edge types (created for you automatically) that contain a field, node, that is the same :node_type you passed earlier (:pet).pageInfo is a field that contains information about the current view; the startCursor, endCursor, hasPreviousPage, and hasNextPage fields.Pagination DirectionBy default, connections will support bidirectional pagination, but you can also restrict the connection to just the :forward or :backward direction using the :paginate argument:connection field :pets, node_type: :pet, paginate: :forward doCustomizing TypesIf you'd like to add additional fields to the generated connection and edge types, you can do that by providing a block to the connection macro, eg, here we add a field, :twice_edges_count to the connection type, and another, :node_name_backwards, to the edge type:connection node_type: :pet do field :twice_edges_count, :integer do resolve fn _, %{source: conn} -&gt; {:ok, length(conn.edges) * 2} end end edge do field :node_name_backwards, :string do resolve fn _, %{source: edge} -&gt; {:ok, edge.node.name |&gt; String.reverse} end end end endJust remember that if you use the block form of connection, you must call the edge macro within the block.Customizing the node itselfIt's also possible to customize the way the node field of the connection's edge is resolved. This can, for example, be useful if you're working with a NoSQL database that returns relationships as lists of IDs. Consider the following example which paginates over the user's account array, but resolves each one of them independently.object :account do field :id, non_null(:id) field :name, :string end connection node_type :account do edge do field :node, :account do resolve fn %{node: id}, _args, _info -&gt; Account.find(id) end end end end object :user do field :name, string connection field :accounts, node_type: :account do resolve fn %{accounts: accounts}, _args, _info -&gt; Absinthe.Relay.Connection.from_list(ids, args) end end end This would resolve the connections into a list of the user's associated accounts, and then for each node find that particular account (preferrably batched).Creating ConnectionsThis module provides two functions that mirror similar JavaScript functions, from_list/2,3 and from_slice/2,3. We also provide from_query/2,3 if you have Ecto as a dependency for convenience.Use from_list when you have all items in a list that you're going to paginate over.Use from_slice when you have items for a particular request, and merely need a connection produced from these items.Supplying Edge InformationIn some cases you may wish to supply extra information about the edge so that it can be used in the schema. For example:connection node_type: :user do edge do field :role, :string end endTo do this, pass from_list a list of 2-element tuples where the first element is the node and the second element either a map or a keyword list of the edge attributes.[ {%{name: &quot;Jim&quot;}, role: &quot;owner&quot;}, {%{name: &quot;Sari&quot;}, role: &quot;guest&quot;}, {%{name: &quot;Lee&quot;}, %{role: &quot;guest&quot;}}, # This is OK, too ] |&gt; Connection.from_list(args)This is useful when using ecto to include relationship information on the edge itself via from_query:# In a UserResolver module alias Absinthe.Relay def list_teams(args, %{context: %{current_user: user}}) do TeamAssignment |&gt; from |&gt; where([a], a.user_id == ^user.id) |&gt; join(:left, [a], t in assoc(a, :team)) |&gt; select([a,t], {t, map(a, [:role])}) |&gt; Relay.Connection.from_query(&amp;Repo.all/1, args) endBe aware that if you pass :node in the arguments provided as the second element of the edge tuple, that value will be ignored and a warning logged.If you provide a :cursor argument, then your value will override the internally generated cursor. This may or may not be desirable.Schema MacrosFor more details on connection-related macros, see Absinthe.Relay.Connection.Notation.","ref":"Absinthe.Relay.Connection.html","title":"Absinthe.Relay.Connection","type":"module"},{"doc":"Rederives the offset from the cursor string.","ref":"Absinthe.Relay.Connection.html#cursor_to_offset/1","title":"Absinthe.Relay.Connection.cursor_to_offset/1","type":"function"},{"doc":"Get a connection object for a list of data.A simple function that accepts a list and connection arguments, and returns a connection object for use in GraphQL.The data given to it should constitute all data that further pagination requests may page over. As such, it may be very inefficient if you're pulling data from a database which could be used to more directly retrieve just the desired data.See also from_query and from_slice.Example#in a resolver module @items ~w(foo bar baz) def list(args, _) do Connection.from_list(@items, args) end","ref":"Absinthe.Relay.Connection.html#from_list/3","title":"Absinthe.Relay.Connection.from_list/3","type":"function"},{"doc":"Build a connection from an Ecto QueryThis will automatically set a limit and offset value on the Ecto query, and then run the query with whatever function is passed as the second argument.Notes:Your query MUST have an order_by value. Offset does not make sense without one.last: N must always be acompanied by either a before: argument to the query, or an explicit count: option to the from_query call. Otherwise it is impossible to derive the required offset.Example# In a PostResolver module alias Absinthe.Relay def list(args, %{context: %{current_user: user}}) do Post |&gt; where(author_id: ^user.id) |&gt; Relay.Connection.from_query(&amp;Repo.all/1, args) end","ref":"Absinthe.Relay.Connection.html#from_query/4","title":"Absinthe.Relay.Connection.from_query/4","type":"function"},{"doc":"Build a connection from sliceThis function assumes you have already retrieved precisely the number of items to be returned in this connection request.Often this function is used internally by other functions.ExampleThis is basically how our from_query/2 function works if we didn't need to worry about backwards pagination.# In PostResolver module alias Absinthe.Relay def list(args, %{context: %{current_user: user}}) do {:ok, :forward, limit} = Connection.limit(args) {:ok, offset} = Connection.offset(args) Post |&gt; where(author_id: ^user.id) |&gt; limit(^limit) |&gt; offset(^offset) |&gt; Repo.all |&gt; Relay.Connection.from_slice(offset) end","ref":"Absinthe.Relay.Connection.html#from_slice/3","title":"Absinthe.Relay.Connection.from_slice/3","type":"function"},{"doc":"The direction and desired number of records in the pagination arguments.","ref":"Absinthe.Relay.Connection.html#limit/1","title":"Absinthe.Relay.Connection.limit/1","type":"function"},{"doc":"Same as limit/1 with user provided upper bound.Often backend developers want to provide a maximum value above which no more records can be retrieved, no matter how many are asked for by the front end.This function provides that capability. For use with from_list or from_query use the :max option on those functions.","ref":"Absinthe.Relay.Connection.html#limit/2","title":"Absinthe.Relay.Connection.limit/2","type":"function"},{"doc":"Returns the offset for a page.The limit is required because if using backwards pagination the limit will be subtracted from the offset.If no offset is specified in the pagination arguments, this will return nil.","ref":"Absinthe.Relay.Connection.html#offset/1","title":"Absinthe.Relay.Connection.offset/1","type":"function"},{"doc":"Creates the cursor string from an offset.","ref":"Absinthe.Relay.Connection.html#offset_to_cursor/1","title":"Absinthe.Relay.Connection.offset_to_cursor/1","type":"function"},{"doc":"An opaque pagination cursorInternally it has the base64 encoded structure:arrayconnection::$offset","ref":"Absinthe.Relay.Connection.html#t:cursor/0","title":"Absinthe.Relay.Connection.cursor/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Connection.html#t:edge/0","title":"Absinthe.Relay.Connection.edge/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Connection.html#t:from_query_opts/0","title":"Absinthe.Relay.Connection.from_query_opts/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Connection.html#t:from_slice_opts/0","title":"Absinthe.Relay.Connection.from_slice_opts/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Connection.html#t:limit/0","title":"Absinthe.Relay.Connection.limit/0","type":"type"},{"doc":"Offset from zero.Negative offsets are not supported.","ref":"Absinthe.Relay.Connection.html#t:offset/0","title":"Absinthe.Relay.Connection.offset/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Connection.html#t:page_info/0","title":"Absinthe.Relay.Connection.page_info/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Connection.html#t:pagination_direction/0","title":"Absinthe.Relay.Connection.pagination_direction/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Connection.html#t:t/0","title":"Absinthe.Relay.Connection.t/0","type":"type"},{"doc":"Macros used to define Connection-related schema entitiesSee Absinthe.Relay.Connection for more information.If you wish to use this module on its own without use Absinthe.Relay you need to include@pipeline_modifier Absinthe.Relay.Schemain your root schema module.","ref":"Absinthe.Relay.Connection.Notation.html","title":"Absinthe.Relay.Connection.Notation","type":"module"},{"doc":"","ref":"Absinthe.Relay.Connection.Notation.html#additional_types/2","title":"Absinthe.Relay.Connection.Notation.additional_types/2","type":"function"},{"doc":"","ref":"Absinthe.Relay.Connection.Notation.html#connection/1","title":"Absinthe.Relay.Connection.Notation.connection/1","type":"macro"},{"doc":"Define a connection type for a given node type.ExamplesA basic connection for a node type, :pet. This well generate simple :pet_connection and :pet_edge types for you:connection node_type: :petYou can provide a custom name for the connection type (just don't include the word &quot;connection&quot;). You must still provide the :node_type. You can create as many different connections to a node type as you want.This example will create a connection type, :favorite_pets_connection, and an edge type, :favorite_pets_edge:connection :favorite_pets, node_type: :petYou can customize the connection object just like any other object:connection :favorite_pets, node_type: :pet do field :total_age, :float do resolve fn _, %{source: conn} -&gt; sum = conn.edges |&gt; Enum.map(fn edge -&gt; edge.node.age) |&gt; Enum.sum {:ok, sum} end end edge do # ... end endJust remember that if you use the block form of connection, you must call the edge macro within the block to make sure the edge type is generated. See the edge macro below for more information.","ref":"Absinthe.Relay.Connection.Notation.html#connection/2","title":"Absinthe.Relay.Connection.Notation.connection/2","type":"macro"},{"doc":"","ref":"Absinthe.Relay.Connection.Notation.html#connection/3","title":"Absinthe.Relay.Connection.Notation.connection/3","type":"macro"},{"doc":"Customize the edge type.Examplesconnection node_type: :pet do # ... edge do field :node_name_backwards, :string do resolve fn _, %{source: edge} -&gt; {:ok, edge.node.name |&gt; String.reverse} end end end end","ref":"Absinthe.Relay.Connection.Notation.html#edge/2","title":"Absinthe.Relay.Connection.Notation.edge/2","type":"macro"},{"doc":"","ref":"Absinthe.Relay.Connection.Notation.html#fillout/2","title":"Absinthe.Relay.Connection.Notation.fillout/2","type":"function"},{"doc":"Middleware to support the macros located in:For Relay Modern: Absinthe.Relay.Mutation.Notation.ModernFor Relay Classic: Absinthe.Relay.Mutation.Notation.ClassicPlease see those modules for specific instructions.","ref":"Absinthe.Relay.Mutation.html","title":"Absinthe.Relay.Mutation","type":"module"},{"doc":"Support for Relay Classic mutations with single inputs and client mutation IDs.The payload macro can be used by schema designers to support mutation fields that receive a single input object argument with a client mutation ID and return that ID as part of the response payload.More information can be found at https://facebook.github.io/relay/docs/guides-mutations.htmlExampleIn this example we add a mutation field :simple_mutation that accepts an input argument (which is defined for us automatically) which contains an :input_data field.We also declare the output will contain a field, :result.Notice the resolve function doesn't need to know anything about the wrapping input argument -- it only concerns itself with the contents -- and the client mutation ID doesn't need to be dealt with, either. It will be returned as part of the response payload automatically.mutation do payload field :simple_mutation do input do field :input_data, non_null(:integer) end output do field :result, :integer end resolve fn %{input_data: input_data}, _ -&gt; # Some mutation side-effect here {:ok, %{result: input_data * 2}} end end endHere's a query document that would hit this field:mutation DoSomethingSimple { simpleMutation(input: {inputData: 2, clientMutationId: &quot;abc&quot;}) { result clientMutationId } }And here's the response:{ &quot;data&quot;: { &quot;simpleMutation&quot;: { &quot;result&quot;: 4, &quot;clientMutationId&quot;: &quot;abc&quot; } } }Note the above code would create the following types in our schema, ad hoc:SimpleMutationInputSimpleMutationPayloadFor this reason, the identifier passed to payload field must be unique across your schema.The Escape HatchThe mutation macros defined here are just for convenience; if you want something that goes against these restrictions, don't worry! You can always just define your types and fields using normal (field, arg, input_object, etc) schema notation macros as usual.","ref":"Absinthe.Relay.Mutation.Notation.Classic.html","title":"Absinthe.Relay.Mutation.Notation.Classic","type":"module"},{"doc":"","ref":"Absinthe.Relay.Mutation.Notation.Classic.html#additional_types/2","title":"Absinthe.Relay.Mutation.Notation.Classic.additional_types/2","type":"function"},{"doc":"","ref":"Absinthe.Relay.Mutation.Notation.Classic.html#fillout/2","title":"Absinthe.Relay.Mutation.Notation.Classic.fillout/2","type":"function"},{"doc":"Defines the input type for your payload field. See the module documentation for an example.","ref":"Absinthe.Relay.Mutation.Notation.Classic.html#input/2","title":"Absinthe.Relay.Mutation.Notation.Classic.input/2","type":"macro"},{"doc":"Defines the output (payload) type for your payload field. See the module documentation for an example.","ref":"Absinthe.Relay.Mutation.Notation.Classic.html#output/2","title":"Absinthe.Relay.Mutation.Notation.Classic.output/2","type":"macro"},{"doc":"","ref":"Absinthe.Relay.Mutation.Notation.Classic.html#payload/1","title":"Absinthe.Relay.Mutation.Notation.Classic.payload/1","type":"macro"},{"doc":"Define a mutation with a single input and a client mutation ID. See the module documentation for more information.","ref":"Absinthe.Relay.Mutation.Notation.Classic.html#payload/2","title":"Absinthe.Relay.Mutation.Notation.Classic.payload/2","type":"macro"},{"doc":"Convenience macros for Relay Modern mutations.(If you want clientMutationId handling, see Absinthe.Relay.Mutation.Notation.Classic!)The payload macro can be used by schema designers to support mutation fields that receive either:A single non-null input object argument (using the input macro in this module)Any arguments you want to use (using the normal arg macro)More information can be found at https://facebook.github.io/relay/docs/mutations.htmlExampleIn this example we add a mutation field :simple_mutation that accepts an input argument of a new type (which is defined for us because we use the input macro), which contains an :input_data field.We also declare the output will contain a field, :result.Notice the resolve function doesn't need to know anything about the wrapping input argument -- it only concerns itself with the contents. The input fields are passed to the resolver just like they were declared as separate top-level arguments.mutation do payload field :simple_mutation do input do field :input_data, non_null(:integer) end output do field :result, :integer end resolve fn %{input_data: input_data}, _ -&gt; # Some mutation side-effect here {:ok, %{result: input_data * 2}} end end endHere's a query document that would hit this field:mutation DoSomethingSimple { simpleMutation(input: {inputData: 2}) { result } }And here's the response:{ &quot;data&quot;: { &quot;simpleMutation&quot;: { &quot;result&quot;: 4 } } }Note the above code would create the following types in our schema, ad hoc:SimpleMutationInputSimpleMutationPayloadFor this reason, the identifier passed to payload field must be unique across your schema.Using your own argumentsYou are free to just declare your own arguments instead. The input argument and type behavior is only activated for your mutation field if you use the input macro.You're free to define your own arguments using arg, as usual, with one caveat: don't call one :input.The Escape HatchThe mutation macros defined here are just for convenience; if you want something that goes against these restrictions, don't worry! You can always just define your types and fields using normal (field, arg, input_object, etc) schema notation macros as usual.","ref":"Absinthe.Relay.Mutation.Notation.Modern.html","title":"Absinthe.Relay.Mutation.Notation.Modern","type":"module"},{"doc":"","ref":"Absinthe.Relay.Mutation.Notation.Modern.html#add_input_arg/1","title":"Absinthe.Relay.Mutation.Notation.Modern.add_input_arg/1","type":"function"},{"doc":"","ref":"Absinthe.Relay.Mutation.Notation.Modern.html#additional_types/2","title":"Absinthe.Relay.Mutation.Notation.Modern.additional_types/2","type":"function"},{"doc":"","ref":"Absinthe.Relay.Mutation.Notation.Modern.html#fillout/2","title":"Absinthe.Relay.Mutation.Notation.Modern.fillout/2","type":"function"},{"doc":"Defines the input type for your payload field. See the module documentation for an example.","ref":"Absinthe.Relay.Mutation.Notation.Modern.html#input/2","title":"Absinthe.Relay.Mutation.Notation.Modern.input/2","type":"macro"},{"doc":"Defines the output (payload) type for your payload field. See the module documentation for an example.","ref":"Absinthe.Relay.Mutation.Notation.Modern.html#output/2","title":"Absinthe.Relay.Mutation.Notation.Modern.output/2","type":"macro"},{"doc":"","ref":"Absinthe.Relay.Mutation.Notation.Modern.html#payload/1","title":"Absinthe.Relay.Mutation.Notation.Modern.payload/1","type":"macro"},{"doc":"Define a mutation with a single input and a client mutation ID. See the module documentation for more information.","ref":"Absinthe.Relay.Mutation.Notation.Modern.html#payload/2","title":"Absinthe.Relay.Mutation.Notation.Modern.payload/2","type":"macro"},{"doc":"Support for global object identification.The node macro can be used by schema designers to add required &quot;object identification&quot; support for object types, and to provide a unified interface for querying them.More information can be found at:https://facebook.github.io/relay/docs/graphql-object-identification.html#contenthttps://facebook.github.io/relay/graphql/objectidentification.htmInterfaceDefine a node interface for your schema, providing a type resolver that, given a resolved object can determine which node object type it belongs to.node interface do resolve_type fn %{age: _}, _ -&gt; :person %{employee_count: _}, _ -&gt; :business _, _ -&gt; nil end endThis will create an interface, :node that expects one field, :id, be defined -- and that the ID will be a global identifier.If you use the node macro to create your object types (see &quot;Object&quot; below), this can be easily done, layered on top of the standard object type definition style.FieldThe node field provides a unified interface to query for an object in the system using a global ID. The node field should be defined within your schema query and should provide a resolver that, given a map containing the object type identifier and internal, non-global ID (the incoming global ID will be parsed into these values for you automatically) can resolve the correct value.query do # ... node field do resolve fn %{type: :person, id: id}, _ -&gt; {:ok, Map.get(@people, id)} %{type: :business, id: id}, _ -&gt; {:ok, Map.get(@businesses, id)} end end endThis creates a field, :node, with one argument: :id. This is expected to be a global ID and, once resolved, will result in a value whose type implements the :node interface.Here's how you easly create object types that can be looked up using this field:ObjectTo play nicely with the :node interface and field, explained above, any object types need to implement the :node interface and generate a global ID as the value of its :id field. Using the node macro, you can easily do this while retaining the usual object type definition style.node object :person do field :name, :string field :age, :string endThis will create an object type, :person, as you might expect. An :id field is created for you automatically, and this field generates a global ID; an opaque string that's built using a global ID translator (by default a Base64 implementation). All of this is handled for you automatically by prefixing your object type definition with &quot;node &quot;.By default, type of :id field is ID. But you can pass custom type in :id_type attribute:node interface id_type: :uuid do resolve_type fn ... end end node field id_type: :uuid do resolve fn ... end end node object :thing, id_type: :uuid do field :name, :string endOr you can set it up globally via application config:config Absinthe.Relay, node_id_type: :uuidThe raw, internal value is retrieved using default_id_fetcher/2 which just pattern matches an :id field from the resolved object. If you need to extract/build an internal ID via another method, just provide a function as an :id_fetcher option.For instance, assuming your raw internal IDs were stored as :_id, you could configure your object like this:node object :thing, id_fetcher: &amp;my_custom_id_fetcher/2 do field :name, :string endFor instructions on how to change the underlying method of decoding/encoding a global ID, see Absinthe.Relay.Node.IDTranslator.MacrosFor more details on node-related macros, see Absinthe.Relay.Node.Notation.","ref":"Absinthe.Relay.Node.html","title":"Absinthe.Relay.Node","type":"module"},{"doc":"The default ID fetcher used to retrieve raw, non-global IDs from values.Matches :id out of the value.If it's nil, it returns nilIf it's not nil, it coerces it to a binary using Kernel.to_string/1Examplesiex&gt; default_id_fetcher(%{id: &quot;foo&quot;}) &quot;foo&quot; iex&gt; default_id_fetcher(%{id: 123}) &quot;123&quot; iex&gt; default_id_fetcher(%{id: nil}) nil iex&gt; default_id_fetcher(%{nope: &quot;no_id&quot;}) nil","ref":"Absinthe.Relay.Node.html#default_id_fetcher/2","title":"Absinthe.Relay.Node.default_id_fetcher/2","type":"function"},{"doc":"Parse a global ID, given a schema.To change the underlying method of decoding a global ID, see Absinthe.Relay.Node.IDTranslator.ExamplesFor nil, pass-through:iex&gt; from_global_id(nil, Schema) {:ok, nil}For a valid, existing type in Schema:iex&gt; from_global_id(&quot;UGVyc29uOjE=&quot;, Schema) {:ok, %{type: :person, id: &quot;1&quot;}}For an invalid global ID value:iex&gt; from_global_id(&quot;GHNF&quot;, Schema) {:error, &quot;Could not decode ID value `GHNF&#39;&quot;}For a type that isn't in the schema:iex&gt; from_global_id(&quot;Tm9wZToxMjM=&quot;, Schema) {:error, &quot;Unknown type `Nope&#39;&quot;}For a type that is in the schema but isn't a node:iex&gt; from_global_id(&quot;Tm9wZToxMjM=&quot;, Schema) {:error, &quot;Type `Item&#39; is not a valid node type&quot;}","ref":"Absinthe.Relay.Node.html#from_global_id/2","title":"Absinthe.Relay.Node.from_global_id/2","type":"function"},{"doc":"Generate a global ID given a node type name and an internal (non-global) ID given a schema.To change the underlying method of encoding a global ID, see Absinthe.Relay.Node.IDTranslator.Examplesiex&gt; to_global_id(&quot;Person&quot;, &quot;123&quot;) &quot;UGVyc29uOjEyMw==&quot; iex&gt; to_global_id(:person, &quot;123&quot;, SchemaWithPersonType) &quot;UGVyc29uOjEyMw==&quot; iex&gt; to_global_id(:person, nil, SchemaWithPersonType) nil","ref":"Absinthe.Relay.Node.html#to_global_id/3","title":"Absinthe.Relay.Node.to_global_id/3","type":"function"},{"doc":"","ref":"Absinthe.Relay.Node.html#t:global_id/0","title":"Absinthe.Relay.Node.global_id/0","type":"type"},{"doc":"Useful schema helper functions for node IDs.","ref":"Absinthe.Relay.Node.Helpers.html","title":"Absinthe.Relay.Node.Helpers","type":"module"},{"doc":"Wrap a resolver to parse node (global) ID arguments before it is executed.Note: This function is deprecated and will be removed in a future release. Use the Absinthe.Relay.Node.ParseIDs middleware instead.For each argument:If a single node type is provided, the node ID in the argument map will be replaced by the ID specific to your application.If multiple node types are provided (as a list), the node ID in the argument map will be replaced by a map with the node ID specific to your application as :id and the parsed node type as :type.ExamplesParse a node (global) ID argument :item_id as an :item type. This replaces the node ID in the argument map (key :item_id) with your application-specific ID. For example, &quot;123&quot;.resolve parsing_node_ids(&amp;my_field_resolver/2, item_id: :item)Parse a node (global) ID argument :interface_id into one of multiple node types. This replaces the node ID in the argument map (key :interface_id) with map of the parsed node type and your application-specific ID. For example, %{type: :thing, id: &quot;123&quot;}.resolve parsing_node_ids(&amp;my_field_resolver/2, interface_id: [:item, :thing])","ref":"Absinthe.Relay.Node.Helpers.html#parsing_node_ids/2","title":"Absinthe.Relay.Node.Helpers.parsing_node_ids/2","type":"function"},{"doc":"An ID translator handles encoding and decoding a global ID used in a Relay node.This module provides the behaviour for implementing an ID Translator. An example use case of this module would be a translator that encrypts the global ID.To use an ID Translator in your schema there are two methods.Inline Configdefmodule MyApp.Schema do use Absinthe.Schema use Absinthe.Relay.Schema, [ flavor: :modern, global_id_translator: MyApp.Absinthe.IDTranslator ] # ... endMix Configconfig Absinthe.Relay, MyApp.Schema, global_id_translator: MyApp.Absinthe.IDTranslatorExample ID TranslatorA basic example that encodes the global ID by joining the type_name and source_id with &quot;:&quot;.defmodule MyApp.Absinthe.IDTranslator do @behaviour Absinthe.Relay.Node.IDTranslator def to_global_id(type_name, source_id, _schema) do {:ok, &quot;\#{type_name}:\#{source_id}&quot;} end def from_global_id(global_id, _schema) do case String.split(global_id, &quot;:&quot;, parts: 2) do [type_name, source_id] -&gt; {:ok, type_name, source_id} _ -&gt; {:error, &quot;Could not extract value from ID `\#{inspect global_id}`&quot;} end end end","ref":"Absinthe.Relay.Node.IDTranslator.html","title":"Absinthe.Relay.Node.IDTranslator","type":"behaviour"},{"doc":"Converts a globally unique ID to a node's type name and ID.Returns {:ok, type_name, source_id} on success.Returns {:error, binary} on failure.","ref":"Absinthe.Relay.Node.IDTranslator.html#c:from_global_id/2","title":"Absinthe.Relay.Node.IDTranslator.from_global_id/2","type":"callback"},{"doc":"Converts a node's type name and ID to a globally unique ID.Returns {:ok, global_id} on success.Returns {:error, binary} on failure.","ref":"Absinthe.Relay.Node.IDTranslator.html#c:to_global_id/3","title":"Absinthe.Relay.Node.IDTranslator.to_global_id/3","type":"callback"},{"doc":"A basic implementation of Absinthe.Relay.Node.IDTranslator using Base64 encoding.","ref":"Absinthe.Relay.Node.IDTranslator.Base64.html","title":"Absinthe.Relay.Node.IDTranslator.Base64","type":"module"},{"doc":"Macros used to define Node-related schema entitiesSee Absinthe.Relay.Node for examples of use.If you wish to use this module on its own without use Absinthe.Relay you need to include@pipeline_modifier Absinthe.Relay.Schemain your root schema module.","ref":"Absinthe.Relay.Node.Notation.html","title":"Absinthe.Relay.Node.Notation","type":"module"},{"doc":"","ref":"Absinthe.Relay.Node.Notation.html#additional_types/2","title":"Absinthe.Relay.Node.Notation.additional_types/2","type":"function"},{"doc":"","ref":"Absinthe.Relay.Node.Notation.html#fillout/2","title":"Absinthe.Relay.Node.Notation.fillout/2","type":"function"},{"doc":"Define a node interface, field, or object type for a schema.See the Absinthe.Relay.Node module documentation for examples.","ref":"Absinthe.Relay.Node.Notation.html#node/2","title":"Absinthe.Relay.Node.Notation.node/2","type":"macro"},{"doc":"Parse node (global) ID arguments before they are passed to a resolver, checking the arguments against acceptable types.For each argument:If a single node type is provided, the node ID in the argument map will be replaced by the ID specific to your application.If multiple node types are provided (as a list), the node ID in the argument map will be replaced by a map with the node ID specific to your application as :id and the parsed node type as :type.If a GraphQL null value for an ID is found, it will be passed through as nil in either case, since no type can be associated with the value.ExamplesParse a node (global) ID argument :item_id as an :item type. This replaces the node ID in the argument map (key :item_id) with your application-specific ID. For example, &quot;123&quot;.field :item, :item do arg :item_id, non_null(:id) middleware Absinthe.Relay.Node.ParseIDs, item_id: :item resolve &amp;item_resolver/3 endParse a node (global) ID argument :interface_id into one of multiple node types. This replaces the node ID in the argument map (key :interface_id) with map of the parsed node type and your application-specific ID. For example, %{type: :thing, id: &quot;123&quot;}.field :foo, :foo do arg :interface_id, non_null(:id) middleware Absinthe.Relay.Node.ParseIDs, interface_id: [:item, :thing] resolve &amp;foo_resolver/3 endParse a nested structure of node (global) IDs. This behaves similarly to the examples above, but acts recursively when given a keyword list.input_object :parent_input do field :id, non_null(:id) field :children, list_of(:child_input) field :child, non_null(:child_input) end input_object :child_input do field :id, non_null(:id) end mutation do payload field :update_parent do input do field :parent, :parent_input end output do field :parent, :parent end middleware Absinthe.Relay.Node.ParseIDs, parent: [ id: :parent, children: [id: :child], child: [id: :child] ] resolve &amp;resolve_parent/2 end endAs with any piece of middleware, this can configured schema-wide using the middleware/3 function in your schema. In this example all top level query fields are made to support node IDs with the associated criteria in @node_id_rules:defmodule MyApp.Schema do # Schema ... @node_id_rules [ item_id: :item, interface_id: [:item, :thing], ] def middleware(middleware, _, %Absinthe.Type.Object{identifier: :query}) do [{Absinthe.Relay.Node.ParseIDs, @node_id_rules} | middleware] end def middleware(middleware, _, _) do middleware end endUsing with MutationsImportant: Remember that middleware is applied in order. If you're using middleware/3 to apply this middleware to a mutation field (defined using the Absinthe.Relay.Mutation macros) before the Absinthe.Relay.Mutation middleware, you need to include a wrapping top-level :input, since the argument won't be stripped out yet.So, this configuration defined inside of a payload field block:mutation do payload field :change_something do # ... middleware Absinthe.Relay.Node.ParseIDs, profile: [ user_id: :user ] end endNeeds to look like this if you put the ParseIDs middleware first:def middleware(middleware, %Absinthe.Type.Field{identifier: :change_something}, _) do # Note the addition of the `input` level: [{Absinthe.Relay.Node.ParseIDs, input: [profile: [user_id: :user]]} | middleware] end def middleware(middleware, _, _) do middleware endIf, however, you do a bit more advanced surgery to the middleware list and insert Absinthe.Relay.Node.ParseIDs after Absinthe.Relay.Mutation, you don't include the wrapping :input.Compatibility Note for Middleware DevelopersIf you're defining a piece of middleware that modifies field arguments similar to Absinthe.Relay.Mutation does (stripping the outer input argument), you need to set the private :__parse_ids_root so that this middleware can find the root schema node used to apply its configuration. See Absinthe.Relay.Mutation for an example of setting the value, and the find_schema_root!/2 function in this module for how it's used.","ref":"Absinthe.Relay.Node.ParseIDs.html","title":"Absinthe.Relay.Node.ParseIDs","type":"module"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.html#find_schema_root!/2","title":"Absinthe.Relay.Node.ParseIDs.find_schema_root!/2","type":"function"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.html#t:full_result/0","title":"Absinthe.Relay.Node.ParseIDs.full_result/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.html#t:result/0","title":"Absinthe.Relay.Node.ParseIDs.result/0","type":"type"},{"doc":"The rules used to parse node ID arguments.ExamplesDeclare :item_id as only valid with the :item node type:[ item_id: :item ]Declare :item_id be valid as either :foo or :bar types:[ item_id: [:foo, :bar] ]Note that using these two different forms will result in different argument values being passed for :item_id (the former, as a binary, the latter as a map).In the event that the ID is a null, it will be passed-through as nil.See the module documentation for more details.","ref":"Absinthe.Relay.Node.ParseIDs.html#t:rules/0","title":"Absinthe.Relay.Node.ParseIDs.rules/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.html#t:simple_result/0","title":"Absinthe.Relay.Node.ParseIDs.simple_result/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Config.html","title":"Absinthe.Relay.Node.ParseIDs.Config","type":"module"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Config.html#parse!/1","title":"Absinthe.Relay.Node.ParseIDs.Config.parse!/1","type":"function"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Config.html#t:node_t/0","title":"Absinthe.Relay.Node.ParseIDs.Config.node_t/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Config.html#t:t/0","title":"Absinthe.Relay.Node.ParseIDs.Config.t/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Namespace.html","title":"Absinthe.Relay.Node.ParseIDs.Namespace","type":"module"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Namespace.html#t:t/0","title":"Absinthe.Relay.Node.ParseIDs.Namespace.t/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Rule.html","title":"Absinthe.Relay.Node.ParseIDs.Rule","type":"module"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Rule.html#output/2","title":"Absinthe.Relay.Node.ParseIDs.Rule.output/2","type":"function"},{"doc":"","ref":"Absinthe.Relay.Node.ParseIDs.Rule.html#t:t/0","title":"Absinthe.Relay.Node.ParseIDs.Rule.t/0","type":"type"},{"doc":"Used to extend a schema with Relay-specific macros and types.See Absinthe.Relay.","ref":"Absinthe.Relay.Schema.html","title":"Absinthe.Relay.Schema","type":"module"},{"doc":"","ref":"Absinthe.Relay.Schema.html#pipeline/1","title":"Absinthe.Relay.Schema.pipeline/1","type":"function"},{"doc":"Used to extend a module where Absinthe types are defined with Relay-specific macros and types.See Absinthe.Relay.","ref":"Absinthe.Relay.Schema.Notation.html","title":"Absinthe.Relay.Schema.Notation","type":"module"},{"doc":"A valid flavor","ref":"Absinthe.Relay.Schema.Notation.html#t:flavor/0","title":"Absinthe.Relay.Schema.Notation.flavor/0","type":"type"},{"doc":"","ref":"Absinthe.Relay.Schema.Phase.html","title":"Absinthe.Relay.Schema.Phase","type":"module"},{"doc":"","ref":"Absinthe.Relay.Schema.Phase.html#flag_invalid/1","title":"Absinthe.Relay.Schema.Phase.flag_invalid/1","type":"function"},{"doc":"","ref":"Absinthe.Relay.Schema.Phase.html#flag_invalid/2","title":"Absinthe.Relay.Schema.Phase.flag_invalid/2","type":"function"},{"doc":"","ref":"Absinthe.Relay.Schema.Phase.html#inherit_invalid/3","title":"Absinthe.Relay.Schema.Phase.inherit_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Relay.Schema.Phase.html#put_flag/2","title":"Absinthe.Relay.Schema.Phase.put_flag/2","type":"function"},{"doc":"Callback implementation for Absinthe.Phase.run/2.","ref":"Absinthe.Relay.Schema.Phase.html#run/2","title":"Absinthe.Relay.Schema.Phase.run/2","type":"function"}]